<?php
/** 
*
* @package acp
* @version $Id: v3_modules.xml 52 2007-12-09 19:45:45Z jelly_doughnut $
* @copyright (c) 2007 phpBB Group 
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}
		
/**
* @package acp
*/
class acp_banners
{
	var $u_action;
					
	function main($id, $mode)
	{
		global $db, $user, $auth, $template;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;
					
		$user->add_lang('acp/banners');
							
		// Set up the page
		$this->tpl_name 	= 'acp_banners';
		$this->page_title 	= 'ACP_BAN_ADMIN_BANNERS_TITLE';
		
		$action = request_var('m', '');
		$get_ban_id = request_var('b', '');
		$see_last_clicks = request_var('see_last_clicks', '');
		$ajout = request_var('add', '');
		$delete = request_var('delete', ''); 
		$edit = request_var('edit', ''); 
		
		$sql = "SELECT ban_id, ban_name, ban_image, ban_url, ban_position, ban_display 
				FROM " . BANNERS_TABLE . "";
		$result = $db->sql_query($sql);
		
		while( $row = $db->sql_fetchrow($result) )
		{
			$banners[] = $row;
			$banners_ma[$row['ban_id']] = $row;
		}
		
		// Mod statistic
		if ( $action == 'stats' && !empty($get_ban_id) )
		{
			$banner_gi = $banners_ma[$get_ban_id];
			$banners_clicks = 0;
			
			$sql = "SELECT lb.ban_id, lb.user_id, lb.ban_time, u.user_id, u.username 
					FROM " . LOG_BANNERS_TABLE . " lb
					LEFT JOIN " . USERS_TABLE . " u
					ON u.user_id = lb.user_id
					WHERE lb.ban_id = '" . $get_ban_id . "'";
			$result = $db->sql_query($sql);
			
			while( $row = $db->sql_fetchrow($result) )
			{
				$banners_clicks++;

				$last_click_user[$banners_clicks] = $row['user_id'];
				$last_click_username[$banners_clicks] = $row['username'];
				$last_click_time[$banners_clicks] = $row['ban_time'];
			}
			
			if ( !empty($see_last_clicks) )
			{
				$template->assign_block_vars('last_clicks', array());
				
				for ( $i = $banners_clicks; $i > 0; $i-- )
				{
					$sql_user = 'SELECT user_id, username, user_colour
						FROM ' . USERS_TABLE . "
						WHERE user_id = '" . $last_click_user[$i]. "'";
					$result_user = $db->sql_query($sql_user);
					$user_ok = $db->sql_fetchrow($result_user);
					$user_link = get_username_string('full', $user_ok['user_id'], $user_ok['username'], $user_ok['user_colour']);
				
					$template->assign_block_vars('last_clicks.last_clicks_list', array(
						'USERNAME' => $user_link,
						'TIME' => $user->format_date($last_click_time[$i]),
						'S_ROW_COUNT2' => $i,
					));
				}
			}
			
			$sql_user = 'SELECT user_id, username, user_colour
				FROM ' . USERS_TABLE . "
				WHERE user_id = '" . $last_click_user[$banners_clicks]. "'";
			$result_user = $db->sql_query($sql_user);
			$user_ok = $db->sql_fetchrow($result_user);
			$user_link = get_username_string('full', $user_ok['user_id'], $user_ok['username'], $user_ok['user_colour']);
			
			$field_clicks_v = request_var('derclicks', 50);
			
			$template->assign_block_vars('stats', array(
				'BAN_NAME' => $banner_gi['ban_name'],
				'BAN_IMAGE' => $banner_gi['ban_image'],
				'BAN_URL' => $banner_gi['ban_url'],
				
				'LAST_CLICK_USER' => $user_link,
				'LAST_CLICK_TIME' => $user->format_date($last_click_time[1]),
				'BANNERS_CLICKS' => $banners_clicks,
				'SEE_LAST_CLICKS' => sprintf($user->lang['ACP_BAN_BAN_SEE_LAST_CLICKS'], '<input type="text" size="3" name="derclicks" value="' . $field_clicks_v . '">')
			));
		}
		
		//Ajout de bannieres
		if (! empty($ajout))
		{
			$ban_name = request_var('ban_name', '');
			$ban_image = request_var('ban_image', '');
			$ban_url = request_var('ban_url', '');
			$ban_position = request_var('ban_position', '');
			$ban_display = request_var('ban_display', '');
			if ( empty($ban_name) || empty($ban_image) || empty($ban_url) )
			{
				trigger_error($user->lang['ACP_BAN_FIELDS_EMPTY'] . adm_back_link($this->u_action), E_USER_WARNING);
			}
			
			$sql = "INSERT INTO " . BANNERS_TABLE . " VALUES( NULL, '" . htmlspecialchars(addslashes($ban_name)) . "', '" . htmlspecialchars(addslashes($ban_image)) . "', '" . htmlspecialchars(addslashes($ban_url)) . "', '" . intval($ban_position) . "', '" . intval($ban_display) . "')";
			$db->sql_query($sql);

			trigger_error($user->lang['ACP_BAN_BANNERS_UPDATED'] . adm_back_link($this->u_action));

		}
		//Suppression de bannieres
		else if ( !empty($delete))
		{
			for ( $d = 0; $d < count($banners); $d++ )
			{ 
				$ban_delete = request_var('ban_delete' . $d, '');
				if ( !empty($ban_delete) )
				{
					$sql = "DELETE FROM " . BANNERS_TABLE . "
							WHERE ban_id = '" . $banners[$d]['ban_id'] . "'";
					$db->sql_query($sql);
				}
			}
			
			trigger_error($user->lang['ACP_BAN_BANNERS_UPDATED'] . adm_back_link($this->u_action));
		}
		//Edition de bannieres
		else if ( !empty($edit) )
		{
			for ( $e = 0; $e < count($banners); $e++ )
			{ 
				$ban_name = request_var('ban_name' . $e, '');
				$ban_image = request_var('ban_image' . $e, '');
				$ban_url = request_var('ban_url' . $e, '');
				$ban_position = request_var('ban_position' . $e, 0);
				$ban_display = request_var('ban_display' . $e, 0);
				
				$sql = "UPDATE " . BANNERS_TABLE . "
						SET ban_name = '" . htmlspecialchars(addslashes($ban_name)) . "', ban_image = '" . htmlspecialchars(addslashes($ban_image)) . "', ban_url = '" . htmlspecialchars(addslashes($ban_url)) . "', ban_position = '" . intval($ban_position) . "', ban_display = '" . intval($ban_display) . "'
						WHERE ban_id = '" . $banners[$e]['ban_id'] . "'";
				$db->sql_query($sql);
			}
			
			trigger_error($user->lang['ACP_BAN_BANNERS_UPDATED'] . adm_back_link($this->u_action));
		}
		
		for ( $i = 0; $i < count($banners); $i++ )
		{
			
			$template->assign_block_vars('banners', array(
				'BAN_ID' => $i,
				'BAN_NAME' => $banners[$i]['ban_name'],
				'U_CLICKS' => $this->u_action . '&amp;m=stats&amp;b=' . $banners[$i]['ban_id'],
				'BAN_IMAGE' => $banners[$i]['ban_image'],
				'BAN_URL' => $banners[$i]['ban_url'],
				'S_BAN_POSITION_HEADER' => $banners[$i]['ban_position'] == BAN_HEADER ? true : false,
				'S_BAN_POSITION_FOOTER' => $banners[$i]['ban_position'] == BAN_FOOTER ? true : false,
				'BAN_DISPLAY' => $banners[$i]['ban_display'],
				'S_ROW_COUNT' => $i,
			));
		}

		$template->assign_vars(array(
			'L_ADMIN_BANNERS_TITLE' => $user->lang['ACP_BAN_ADMIN_BANNERS_TITLE'],
			'L_ADMIN_BANNERS_EXPLAIN' => $user->lang['ACP_BAN_ADMIN_BANNERS_EXPLAIN'],
			
			'L_NAME' => $user->lang['ACP_BAN_NAME'],
			'L_IMAGE' => $user->lang['ACP_BAN_IMAGE'],
			'L_URL' => $user->lang['ACP_BAN_URL'],
			'L_POSITION' => $user->lang['ACP_BAN_POSITION'],
			'L_DISPLAY' => $user->lang['ACP_BAN_DISPLAY'],
			'L_HEADER' => $user->lang['ACP_BAN_HEADER'],
			'L_FOOTER' => $user->lang['ACP_BAN_FOOTER'],
			'L_CLICS' => $user->lang['ACP_BAN_CLICKS'],
			'L_STATS' => $user->lang['ACP_BAN_STATS'],
			'L_DESCRIPTION' => $user->lang['ACP_BAN_DESCRIPTION'],
			'L_NB_CLICKS' => $user->lang['ACP_BAN_NB_CLICKS'],
			'L_LAST_CLICK' => $user->lang['ACP_BAN_LAST_CLICK'],
			
			'L_ADD' => $user->lang['ACP_BAN_ADD'],
			'L_EDIT' => $user->lang['ACP_BAN_EDIT'],
			'L_DELETE' => $user->lang['ACP_BAN_DELETE'],
			'U_ACTION' => $this->u_action
		));

	}
}			
?>